## Beagle_SDR_GPS-master.zip

=== Makefile ===
VERSION_MAJ = 1
VERSION_MIN = 332

REPO_NAME = Beagle_SDR_GPS
DEBIAN_VER = 8.5

# Caution: software update mechanism depends on format of first two lines in this file

#
# Makefile for KiwiSDR project
#
# Copyright (c) 2014-2019 John Seamons, ZL/KF6VO
#

#
# This Makefile can be run on both a build machine (I use a MacBook Pro) and the
# BeagleBone Black target (Debian release).
# Which machine you're on is figured out by this:
#
#	DEBIAN_DEVSYS = $(shell grep -q -s Debian /etc/dogtag; echo $$?)
#	DEBIAN = 0
#	NOT_DEBIAN = 1
#	DEVSYS = 2
#	ifeq ($(DEBIAN_DEVSYS),$(DEBIAN))
#		...
#	ifeq ($(DEBIAN_DEVSYS),$(DEVSYS))
#		...
#
# The '/etc/dogtag' file is present on the Beagle and not on the dev machine.
# Grep returns 0 if "Debian" is found in /etc/dogtag, 1 if it isn't and 2 if /etc/dogtag doesn't exist.
# This same mechanism is used in the wrapper shell script because device tree files need to be
# loaded only on the Beagle.
#

#
# installing FFTW:
#
#	to create /usr/local/lib/libfftw3f.a (the 'f' in '3f' means single precision)
#	Mac:
#		download the sources from fftw.org
#		./configure --enable-single
#		make
#		(sudo) make install
#	BeagleBone Black, Debian:
#		the Makefile automatically installs the package using apt-get
#


################################
# build environment detection
################################
ARCH = sitara
PLATFORM = beaglebone_black

DEBIAN_DEVSYS = $(shell grep -q -s Debian /etc/dogtag; echo $$?)
DEBIAN = 0
NOT_DEBIAN = 1
DEVSYS = 2

DEBIAN_7 = $(shell test -f /sys/devices/platform/bone_capemgr/slots; echo $$?)
UNAME = $(shell uname)


################################
# compiler/option selection
################################

ifeq ($(DEBIAN_DEVSYS),$(DEVSYS))
ifeq ($(UNAME),Darwin)
	CC = clang
	CPP = clang++
	CPP_FLAGS += -std=gnu++11
else
# try clang on your development system (if you have it) -- it's better
#	CC = clang
#	CPP = clang++

	CC = gcc
	CPP = g++
endif
endif

ifeq ($(DEBIAN_DEVSYS),$(DEBIAN))
ifeq ($(DEBIAN_7),1)
# clang 3.0 available on Debian 7.9 doesn't work
	CC = gcc
	CPP = g++
	CFLAGS += -DKIWI_DEBIAN7
# needed for iq_display.cpp et al using g++ (-std=gnu++11 isn't available on Debian 7.9)
	CPP_FLAGS += -std=gnu++0x
else
# clang(-3.5) on Debian 8.5 compiles project in 2 minutes vs 5 for gcc
	CMD_DEPS_DEBIAN = /usr/bin/clang
	CC = clang

# To use clang address sanitizer build with "make ASAN=1 OPT=O0" on target using alias "masan"
# There are shell aliases "masan" and "masan0" for these.
# Use gdb "asan" alias to set breakpoint necessary to backtrace address errors.
ifeq ($(ASAN),)
	CPP = clang++
else
	CPP = clang++-3.9
	CFLAGS += -fsanitize=address -fno-omit-frame-pointer
	#LDFLAGS += -v -fsanitize=address
	LDFLAGS += -fsanitize=address
endif

# needed for iq_display.cpp et al using clang 3.5
	CPP_FLAGS += -std=gnu++11

#	CC = gcc
#	CPP = g++
# needed for iq_display.cpp et al using g++
#	CPP_FLAGS += -std=gnu++11
endif
endif

# make the compiles fast on dev system
ifeq ($(DEBIAN_DEVSYS),$(DEVSYS))
	OPT = O0
else
#	OPT = O0
endif

# static analyzer (different from address sanitizer)
# build on devsys or target with "make SAN=1" using alias "msan"
# uses -O0 for speedup when used on target (clang on Debian seems to catch more errors than on OSX)
ifeq ($(SAN),1)
	CPP_FLAGS += -Werror --analyze -DKIWI_STATIC_ANALYSIS
	OPT = O0
endif


################################
# build files/directories
################################

# The built files (generated .cpp/.h files, binaries etc.) are placed outside of the source tree
# into the BUILD_DIR. This is so NFS can be used to share the sources between the
# development machine and the Kiwi Beagle. If the build files were also shared there would
# be file overwrites on one machine when you built on the other (and lots of unnecessary NFS copying
# back and forth. See the nfs and nfsup aliases in /root/.bashrc for NFS setup details.

BUILD_DIR = ../build
OBJ_DIR = $(BUILD_DIR)/obj
OBJ_DIR_O3 = $(OBJ_DIR)_O3
KEEP_DIR = $(BUILD_DIR)/obj_keep
GEN_DIR = $(BUILD_DIR)/gen
TOOLS_DIR = $(BUILD_DIR)/tools

PKGS = pkgs/mongoose
PKGS_O3 = pkgs/jsmn pkgs/sha256 pkgs/TNT_JAMA

PVT_EXT_DIR = ../extensions
PVT_EXT_DIRS = $(sort $(dir $(wildcard $(PVT_EXT_DIR)/*/extensions/*/*)))
INT_EXT_DIRS = $(sort $(dir $(wildcard extensions/*/*)))
EXT_DIRS = extensions $(INT_EXT_DIRS) $(PVT_EXT_DIRS)

PVT_EXTS = $(subst $(PVT_EXT_DIR)/,,$(wildcard $(PVT_EXT_DIR)/*))
INT_EXTS = $(subst /,,$(subst extensions/,,$(wildcard $(INT_EXT_DIRS))))
EXTS = $(INT_EXTS) $(PVT_EXTS)

GPS = gps gps/ka9q-fec gps/GNSS-SDRLIB
_DIRS = pru $(PKGS)
_DIRS_O3 += . $(PKGS_O3) platform/$(PLATFORM) $(EXT_DIRS) rx rx/CuteSDR rx/csdr rx/kiwi $(GPS) ui init support net web arch arch/$(ARCH)

ifeq ($(OPT),O0)
	DIRS = $(_DIRS) $(_DIRS_O3)
	DIRS_O3 =
	OBJ_DIR_WEB = $(OBJ_DIR)
else
	DIRS = $(_DIRS)
	DIRS_O3 = $(_DIRS_O3)
	OBJ_DIR_WEB = $(OBJ_DIR_O3)
endif

VPATH = $(DIRS) $(DIRS_O3)
I = -I$(GEN_DIR) $(addprefix -I,$(DIRS)) $(addprefix -I,$(DIRS_O3)) -I/usr/local/include
H = $(wildcard $(addsuffix /*.h,$(DIRS))) $(wildcard $(addsuffix /*.h,$(DIRS_O3)))
CPP_F = $(wildcard $(addsuffix /*.cpp,$(DIRS)))
CPP_F_O3 = $(wildcard $(addsuffix /*.cpp,$(DIRS_O3)))

# remove generated files
CFILES = $(subst web/web.cpp,,$(CPP_F))
CFILES_O3 = $(subst web/web.cpp,,$(CPP_F_O3))

#CFLAGS_UNSAFE_OPT = -fcx-limited-range -funsafe-math-optimizations
CFLAGS_UNSAFE_OPT = -funsafe-math-optimizations

ifeq ($(DEBIAN_DEVSYS),$(DEVSYS))
# development machine, compile simulation version
	CFLAGS += -g -MMD -DDEBUG -DDEVSYS
	LIBS = -L/usr/local/lib -lfftw3f -lfftw3
	LIBS_DEP = /usr/local/lib/libfftw3f.a /usr/local/lib/libfftw3.a
	CMD_DEPS =
	DIR_CFG = unix_env/kiwi.config
	CFG_PREFIX = dist.

else

# host machine (BBB), only build the FPGA-using version
#	CFLAGS += -mfloat-abi=softfp -mfpu=neon
	CFLAGS +=  -mfpu=neon -mtune=cortex-a8 -mcpu=cortex-a8 -mfloat-abi=hard
#	CFLAGS += -O3
	CFLAGS += -g -MMD -DDEBUG -DHOST
	LIBS = -lfftw3f -lfftw3 -lutil
	LIBS_DEP = /usr/lib/arm-linux-gnueabihf/libfftw3f.a /usr/lib/arm-linux-gnueabihf/libfftw3.a /usr/sbin/avahi-autoipd /usr/bin/upnpc
	CMD_DEPS = $(CMD_DEPS_DEBIAN) /usr/sbin/avahi-autoipd /usr/bin/upnpc /usr/bin/dig /usr/bin/pnmtopng /sbin/ethtool /usr/bin/sshpass
	DIR_CFG = /root/kiwi.config
	CFG_PREFIX =

# -lrt required for clock_gettime() on Debian 7; see clock_gettime(2) man page
ifeq ($(DEBIAN_7),1)
	LIBS += -lrt
endif

endif


################################
# "all" target must be first
################################
.PHONY: all
all: c_ext_clang_conv
	@make c_ext_clang_conv_all


################################
# package install
################################

# install packages for needed libraries or commands
# some of these are prefixed with "-" to keep update from failing if there is damage to /var/lib/dpkg/info
ifeq ($(DEBIAN_DEVSYS),$(DEBIAN))

KEYRING = $(DIR_CFG)/.keyring.dep
$(KEYRING):
ifeq ($(DEBIAN_7),1)
	cp /etc/apt/sources.list /etc/apt/sources.list.orig
	sed -e 's/ftp\.us/archive/' < /etc/apt/sources.list >/tmp/sources.list
	mv /tmp/sources.list /etc/apt/sources.list
endif
	-apt-get install debian-archive-keyring
	-apt-get update
	touch $(KEYRING)

/usr/lib/arm-linux-gnueabihf/libfftw3f.a /usr/lib/arm-linux-gnueabihf/libfftw3.a:
	apt-get -y install libfftw3-dev

/usr/bin/clang:
	apt-get -y install clang

/usr/sbin/avahi-autoipd:
	-apt-get -y install avahi-autoipd

/usr/bin/upnpc:
	-apt-get -y install miniupnpc

/usr/bin/dig:
	-apt-get -y install dnsutils

/usr/bin/pnmtopng:
	-apt-get -y install pnmtopng

/sbin/ethtool:
	-apt-get -y install ethtool

/usr/bin/sshpass:
	-apt-get -y install sshpass
endif


################################
# dependencies
################################
#ALL_DEPS = pru/pru_realtime.bin
#SRC_DEPS = Makefile
SRC_DEPS = 
BIN_DEPS = KiwiSDR.rx4.wf4.bit KiwiSDR.rx8.wf2.bit KiwiSDR.rx3.wf3.bit
#BIN_DEPS = 
DEVEL_DEPS = $(OBJ_DIR_WEB)/web_devel.o $(KEEP_DIR)/edata_always.o $(KEEP_DIR)/edata_always2.o
EMBED_DEPS = $(OBJ_DIR_WEB)/web_embed.o $(OBJ_DIR)/edata_embed.o $(KEEP_DIR)/edata_always.o  $(KEEP_DIR)/edata_always2.o
EXTS_DEPS = $(OBJ_DIR)/ext_init.o

GEN_ASM = $(GEN_DIR)/kiwi.gen.h verilog/kiwi.gen.vh
OUT_ASM = $(GEN_DIR)/kiwi.aout
GEN_VERILOG = $(addprefix verilog/rx/,cic_rx1_12k.vh cic_rx1_20k.vh cic_rx2_12k.vh cic_rx2_20k.vh cic_rx3_12k.vh cic_rx3_20k.vh cic_wf1.vh cic_wf2.vh)
GEN_NOIP2 = $(GEN_DIR)/noip2
ALL_DEPS += $(GEN_ASM) $(OUT_ASM) $(GEN_VERILOG) $(CMD_DEPS) $(GEN_NOIP2)


################################
# conversion to clang
################################

# NB: afterwards have to rerun make to pickup filename change!
ifneq ($(PVT_EXT_DIRS),)
PVT_EXT_C_FILES = $(shell find $(PVT_EXT_DIRS) -name '*.c' -print)
endif

.PHONY: c_ext_clang_conv
ifeq ($(PVT_EXT_C_FILES),)
c_ext_clang_conv:
#	@echo no installed extensions with files needing conversion from .c to .cpp for clang compatibility
else
c_ext_clang_conv:
#	@echo PVT_EXT_C_FILES = $(PVT_EXT_C_FILES)
	@echo convert installed extension .c files to .cpp for clang compatibility
	find $(PVT_EXT_DIRS) -name '*.c' -exec mv '{}' '{}'pp \;
endif

.PHONY: c_ext_clang_conv_all
c_ext_clang_conv_all: $(KEYRING) $(LIBS_DEP) $(ALL_DEPS) $(BUILD_DIR)/kiwi.bin


################################
# Makefile dependencies
################################

# dependence on VERSION_{MAJ,MIN}
MAKEFILE_DEPS = main.cpp
MF_FILES = $(addsuffix .o,$(basename $(notdir $(MAKEFILE_DEPS))))
MF_OBJ = $(addprefix $(OBJ_DIR)/,$(MF_FILES))
MF_O3 = $(wildcard $(addprefix $(OBJ_DIR_O3)/,$(MF_FILES)))
$(MF_OBJ) $(MF_O3): Makefile


################################
# PRU (not currently used)
################################
PASM_INCLUDES = $(wildcard pru/pasm/*.h)
PASM_SOURCE = $(wildcard pru/pasm/*.c)
pas: $(PASM_INCLUDES) $(PASM_SOURCE) Makefile
	$(CC) -Wall -D_UNIX_ -I./pru/pasm $(PASM_SOURCE) -o pas

pru/pru_realtime.bin: pas pru/pru_realtime.p pru/pru_realtime.h pru/pru_realtime.hp
	(cd pru; ../pas -V3 -b -L -l -D_PASM_ -D$(SETUP) pru_realtime.p)


################################
# Verilog generator
################################
$(GEN_VERILOG): $(GEN_DIR)/kiwi.gen.h verilog/rx/cic_gen.c
ifeq ($(DEBIAN_DEVSYS),$(DEVSYS))
	(cd verilog/rx; make)
endif


################################
# FPGA embedded CPU
################################
$(GEN_ASM): kiwi.config $(wildcard e_cpu/asm/*)
	(cd e_cpu; make)
$(OUT_ASM): $(wildcard e_cpu/*.asm)
	(cd e_cpu; make no_gen)


################################
# noip.com DDNS DUC
################################
$(GEN_NOIP2): pkgs/noip2/noip2.c
	(cd pkgs/noip2; make)


################################
# web server content
################################

#
# How the file optimization strategy works:
#
# FIXME
#	talk about: optim website used, NFS_READ_ONLY, EDATA_DEVEL bypass mode (including -fopt argument)
#	x should not be embedding version # in min file, but adding on demand like plain file
#	what to do about version number in .gz files though?
#	no "-zip" for html files because of possible %[] substitution (replace %[] substitutions)
#
# TODO
#	x concat embed
#	EDATA_ALWAYS/2
#	x jpg/png crush in file_optim
#	x clean target that removes .min .gz
#
# CHECK
#	does google analytics html head insert still work?
#	x ant_switch still works?
#	x update from v1.2 still works?
#	mobile works okay?
#
#
# 1) file_optim program is used to create minified and possibly gzipped versions of web server
#	content files (e.g. .js .css .html .jpg .png) Because the optimized versions of individual
#	files are included in the distro the minimization process, which uses an external website and
#	is very time consuming, is not performed by individual Kiwis as part of the update process.
#	But file_optim is run as part of the standard Makefile rules to account for any changes a user
#	may make as part of their own development (i.e. so a make install will continue to work for them)
#
# 2) Web server code has been modified to lookup optimized alternatives first, i.e. a reference to

=== e_cpu/Makefile ===
#
# assembler for the embedded processor
#

BUILD_DIR = ../../build
TOOLS_DIR = $(BUILD_DIR)/tools
GEN_DIR = $(BUILD_DIR)/gen

ASM = $(TOOLS_DIR)/asm

all: $(ASM)
	$(ASM) -o $(GEN_DIR)

$(TOOLS_DIR):
	@mkdir -p $(TOOLS_DIR)

$(GEN_DIR):
	@mkdir -p $(GEN_DIR)

ASM_INCLUDES = $(wildcard asm/*.h)
ASM_SOURCE = $(wildcard asm/*.c)

$(ASM): $(TOOLS_DIR) $(GEN_DIR) $(ASM_INCLUDES) $(ASM_SOURCE) Makefile
	gcc -I. -I./asm -g $(ASM_SOURCE) -o $@

# don't regenerate the .h/.vh files
no_gen: $(ASM)
	$(ASM) -n -o $(GEN_DIR)

debug: $(ASM)
	$(ASM) -n -d -o $(GEN_DIR)

binary: $(ASM)
	$(ASM) -n -b -o $(GEN_DIR)

stat: $(ASM)
	$(ASM) -n -s -o $(GEN_DIR)

clean:
	-rm -rf $(TOOLS_DIR)/asm* $(GEN_DIR)

=== extensions/Makefile ===
# generate calls to extension main routines
#
# these come from the root Makefile:
#	$(EXT_DIRS) contains a list of all extension directory names
#	$(EXTS) contains a list of all extension names

# NB: BUILD_DIR only goes up one level because this Makefile is directly included by ../Makefile
BUILD_DIR = ../build
GEN_DIR = $(BUILD_DIR)/gen

EXT_FILE = $(GEN_DIR)/ext_init.cpp
EXT_INIT = "\textern void $(ext_name)_main(); $(ext_name)_main();\n"

$(EXT_FILE): extensions/Makefile $(EXT_DIRS) extensions/ext_int.h extensions/ext.h
	@echo generating $(EXT_FILE)
	@echo EXT_DIRS = $(EXT_DIRS)
	@echo "// auto-generated file -- do not edit by hand" > $(EXT_FILE)
	@echo "void extint_init() {" >> $(EXT_FILE)
	@echo $(foreach ext_name,$(EXTS),$(EXT_INIT)) >> $(EXT_FILE)1
	@sort -bdf -f $(EXT_FILE)1 >> $(EXT_FILE)
	@rm -f $(EXT_FILE)1
	@echo "}" >> $(EXT_FILE)

=== tools/Makefile ===
UTIL = audio
UTILS = audio integrate hog multiply ext64 decimate security wspr e1b_fec viterbi27_test e1b_code

CMD =

ifeq ($(UTIL),viterbi27_test)
    MORE = viterbi27_port.o
    ARGS = -l 120 -n 1 -e 10 -g 300
endif

ifeq ($(UTIL),e1b_fec)
    MORE = viterbi.o viterbi27_port.o
endif

ifeq ($(UTIL),decimate)
    CMD = /Applications/baudline.app/Contents/Resources/baudline -quadrature -overlays 2 /Users/jks/new.dec2.au
endif

ifeq ($(UTIL),wspr)
 FN_IN = wspr.fs375.cf7040100.iq.s16.dat
 FN_OUT = wspr.fs12k.cf7040100.iq.f.dat
# CMD = cat $(FN_IN) | csdr convert_s16_f | csdr fir_interpolate_cc 32 0.002 | dd bs=8 count=1440000 > $(FN_OUT); xz --keep --force $(FN_OUT)
 CMD = cat $(FN_IN) | csdr convert_s16_f | csdr plain_interpolate_cc 32 | csdr bandpass_fir_fft_cc -0.015625 0.015625 0.002 | dd bs=8 count=1440000 > $(FN_OUT); xz --keep --force $(FN_OUT)
endif

DEBIAN_DEVSYS = $(shell grep -q -s Debian /etc/dogtag; echo $$?)
DEBIAN = 0
NOT_DEBIAN = 1
DEVSYS = 2

ifeq ($(DEBIAN_DEVSYS),$(DEVSYS))
	CFLAGS += -DDEVSYS
else
endif

ARCH = sitara
PLATFORM = beaglebone_black
PKGS = pkgs/mongoose pkgs/jsmn pkgs/parson

GPS = gps gps/ka9q-fec gps/GNSS-SDRLIB
DIRS = . pru $(PKGS) web extensions
DIRS += platform/$(PLATFORM) $(EXT_DIRS) rx rx/CuteSDR rx/csdr $(GPS) ui support arch arch/$(ARCH)
VPATH = $(addprefix ../,$(DIRS))
I = $(addprefix -I../,$(DIRS)) -I/usr/local/include

all: $(UTIL)

$(UTIL): $(UTIL).o $(MORE)
	g++ $(CFLAGS) $(I) -o $@ $?

%.o: %.cpp
	clang++ $(CFLAGS) $(I) -c $<

run: $(UTIL)
	./$(UTIL) $(ARGS)
	$(CMD)

clean:
	rm -f $(UTILS) *.o *.dat *.xz

=== verilog/Makefile ===
#
# When running Vivado on a machine/OS different from where the Kiwi sources are kept,
# and those two machines are connected via a shared folder, specify the shared folder directory
# with V_SRC_DIR and use the makefile targets "cv2" and "cb" to copy sources and results back and forth.
#
# When building in batch mode, as opposed to using the Vivado UI, V_SRC_DIR is passed to the tcl script
# to specify where to place the resulting .bit files.
#
# V_SRC_DIR can be set as a global environment variable else it will default to the value below.
#

ifeq ($(V_SRC_DIR)x,x)
    V_SRC_DIR = /media/sf_shared
endif

all:
	@reset
	@echo "build project with Vivado via tcl"
	time vivado -mode batch -source make_proj.tcl -tclargs --result_dir $(V_SRC_DIR)
	
rebuild:
	@reset
	@echo "rebuild project ip with Vivado via tcl"
	rm -rf KiwiSDR generated/*
	mkdir -p generated
	time vivado -mode batch -source make_proj.tcl -tclargs --result_dir $(V_SRC_DIR) --regen_ip
	
cv:
	@echo "you probably want to use \"make cv2\" here"

# command to "copy verilog" from KiwiSDR distribution into our build directory
# designed to complement the "make cv" command run in the KiwiSDR server build directory
EXCLUDE_RSYNC = ".DS_Store" "KiwiSDR/" "generated" ".Xil/" "vivado.*"
cv2:
	rsync -av --delete $(addprefix --exclude , $(EXCLUDE_RSYNC)) $(V_SRC_DIR)/KiwiSDR/ .
#	rsync -av --delete --exclude .DS_Store $(V_SRC_DIR)/KiwiSDR.Vivado.2014.4.ip/ ../import_ip
	rsync -av --delete --exclude .DS_Store $(V_SRC_DIR)/KiwiSDR.Vivado.2017.4.ip/ ../import_ip

cb:
	cp ../*.runs/impl_1/KiwiSDR.bit $(V_SRC_DIR)

ts:
	-tail -f KiwiSDR/KiwiSDR.runs/synth_1/runme.log

cs:
	cat KiwiSDR/KiwiSDR.runs/synth_1/runme.log

ti:
	-tail -f KiwiSDR/KiwiSDR.runs/impl_1/runme.log

ci:
	cat KiwiSDR/KiwiSDR.runs/impl_1/runme.log

RSYNC_REV_INC = $(addprefix --include=, "*.veo" "*.xci" "*.xml")
cip_rev:
	rsync -av --delete-excluded --prune-empty-dirs --include "*/"  $(RSYNC_REV_INC) --exclude="*" ../KiwiSDR.srcs/sources_1/ip/ ../import_ip/
	rsync -av --delete --exclude .DS_Store ../import_ip/ $(V_SRC_DIR)/KiwiSDR.ip

cm:
	cp kiwi_map.mrp kiwi_map_mrp.html $(V_SRC_DIR)
	cp KiwiSDR.syr kiwi_syr.html $(V_SRC_DIR)
	cp KiwiSDR.twr kiwi_twr.html $(V_SRC_DIR)
	cp KiwiSDR.twx $(V_SRC_DIR)

cp:
	cp KiwiSDR.pwr $(V_SRC_DIR)

clean:
	rm -f kiwi.coe

=== web/Makefile ===
# filter out previously optimized
FILES_EMBED_JS_F = $(filter-out %.gz,$(filter-out %.min.js,$(FILES_EMBED_JS)))
FILES_EMBED_JS_F2 = $(shell $(FILE_OPTIM) -t1 -u -js $(FILES_EMBED_JS_F) 2> /dev/null)
FILES_EMBED_JS_PKG = $(FILES_EMBED_JS_F)

FILES_EMBED_JS_NOPKG_F = $(filter-out %.gz,$(filter-out %.min.js,$(FILES_EMBED_JS_NOPKG)))
FILES_EMBED_JS_NOPKG2 = $(shell $(FILE_OPTIM) -t2 -u -js $(FILES_EMBED_JS_NOPKG_F) 2> /dev/null)

#FILES_EMBED_CSS_F = $(filter-out %.gz,$(filter-out %.min.js,$(FILES_EMBED_CSS)))
# correct css override order
FILES_EMBED_CSS_KEEP_MIN  = web/pkgs/font-awesome-4.6.3/css/font-awesome.css
FILES_EMBED_CSS_F  = web/pkgs/text-security/text-security-disc.css
FILES_EMBED_CSS_F += web/pkgs/w3.css
FILES_EMBED_CSS_F += web/kiwi/w3_ext.css
FILES_EMBED_CSS_F += web/openwebrx/openwebrx.css
FILES_EMBED_CSS_F += web/kiwi/kiwi.css
FILES_EMBED_CSS_PKG = $(FILES_EMBED_CSS_F) $(FILES_EMBED_CSS_KEEP_MIN)

FILES_EMBED_HTML_F = $(filter-out %.gz,$(filter-out %.min.js,$(FILES_EMBED_HTML)))
FILES_EMBED_HTML_F2 = $(subst web/,,$(shell $(FILE_OPTIM) -t3 -u -html $(FILES_EMBED_HTML_F) 2> /dev/null))

EMBED_FOPT_W = $(FILES_EMBED_JS_F) $(FILES_EMBED_JS_NOPKG_F) $(FILES_EMBED_CSS_F) $(FILES_EMBED_HTML_F)
EMBED_NW = $(subst web/,,$(FILES_EMBED_MISC)) $(FILES_EMBED_HTML_F2) $(subst web/,,$(FILES_EMBED_JS_NOPKG2)) kiwisdr.min.js.gz kiwisdr.min.css.gz

.PHONY: foptim_files_embed
foptim_files_embed: foptim_embed web/kiwisdr.min.js web/kiwisdr.min.css

.PHONY: foptim_embed
foptim_embed: $(FILE_OPTIM) $(FILES_EMBED_JS_F) $(FILES_EMBED_CSS_F)  $(FILES_EMBED_HTML_F)
	@echo
	@echo '### foptim_embed'
# NB: "-zip" not used here so resulting .min.js files can be packaged
	$(FILE_OPTIM) -t4 $(FILES_EMBED_JS_F) $(FILES_EMBED_CSS_F)
	$(FILE_OPTIM) -t5 -zip $(FILES_EMBED_JS_NOPKG_F)
# no "-zip" for html files because of possible %[] substitution
# FIXME: eliminate %[] for this reason (and others) -- do dynamically in js
	$(FILE_OPTIM) -t6 $(FILES_EMBED_HTML_F)
# FIXME: try zipped pngs
#	$(FILE_OPTIM) -zip $(FILES_EMBED_PNG_F)
	@echo
	@echo FILES_EMBED_JS_PKG = $(FILES_EMBED_JS_PKG)
	@echo FILES_EMBED_CSS_PKG = $(FILES_EMBED_CSS_PKG)

web/kiwisdr.min.js: $(FILES_EMBED_JS_PKG)
	cat $(FILES_EMBED_JS_F2) >web/kiwisdr.min.js
	gzip --fast --keep --force web/kiwisdr.min.js

web/kiwisdr.min.css: $(FILES_EMBED_CSS_PKG)
	cat $(FILES_EMBED_CSS_KEEP_MIN) `$(FILE_OPTIM) -t7 -u -css $(FILES_EMBED_CSS_F)` >web/kiwisdr.min.css
	gzip --fast --keep --force web/kiwisdr.min.css

.PHONY: loptim_embed
loptim_embed: $(FILE_OPTIM)
	-ls -la `$(FILE_OPTIM) -l $(EMBED_FOPT_W)` web/kiwisdr.min.js web/kiwisdr.min.css

.PHONY: roptim_embed
roptim_embed: $(FILE_OPTIM)
#	rm -f `$(FILE_OPTIM) -l $(EMBED_FOPT_W)` web/kiwisdr.min.js web/kiwisdr.min.css

=== extensions/SSTV/Makefile ===
#FILES_ALWAYS2 += extensions/SSTV/s1.test.pattern.au
FILES_ALWAYS2 += extensions/SSTV/s2.test.pattern.au
#FILES_ALWAYS2 += extensions/SSTV/r24.test.pattern.au
#FILES_ALWAYS2 += extensions/SSTV/r36.test.pattern.au
#FILES_ALWAYS2 += extensions/SSTV/r36.color.bars.au
#FILES_ALWAYS2 += extensions/SSTV/r72.test.pattern.au
#FILES_ALWAYS2 += extensions/SSTV/pd50.au
#FILES_ALWAYS2 += extensions/SSTV/pd90.au
#FILES_ALWAYS2 += extensions/SSTV/w2120.au
#FILES_ALWAYS2 += extensions/SSTV/w2180.au

=== pkgs/jsmn/Makefile ===
# You can put your build options here
-include config.mk

all: libjsmn.a 

libjsmn.a: jsmn.o
	$(AR) rc $@ $^

%.o: %.c jsmn.h
	$(CC) -c $(CFLAGS) $< -o $@

test: test_default test_strict test_links test_strict_links
test_default: test/tests.c
	$(CC) $(CFLAGS) $(LDFLAGS) $< -o test/$@
	./test/$@
test_strict: test/tests.c
	$(CC) -DJSMN_STRICT=1 $(CFLAGS) $(LDFLAGS) $< -o test/$@
	./test/$@
test_links: test/tests.c
	$(CC) -DJSMN_PARENT_LINKS=1 $(CFLAGS) $(LDFLAGS) $< -o test/$@
	./test/$@
test_strict_links: test/tests.c
	$(CC) -DJSMN_STRICT=1 -DJSMN_PARENT_LINKS=1 $(CFLAGS) $(LDFLAGS) $< -o test/$@
	./test/$@

jsmn_test.o: jsmn_test.c libjsmn.a

simple_example: example/simple.o libjsmn.a
	$(CC) $(LDFLAGS) $^ -o $@

jsondump: example/jsondump.o libjsmn.a
	$(CC) $(LDFLAGS) $^ -o $@

clean:
	rm -f jsmn.o jsmn_test.o example/simple.o
	rm -f libjsmn.a
	rm -f simple_example
	rm -f jsondump

.PHONY: all clean test

=== pkgs/noip2/Makefile ===
BUILD_DIR = ../../../build
GEN_DIR = $(BUILD_DIR)/gen

${GEN_DIR}/noip2: Makefile noip2.c 
	gcc -Wall -g -Dlinux noip2.c -o ${GEN_DIR}/noip2

clean: 
	rm -f ${GEN_DIR}/noip2*

clean_dist: clean
	rm -f NO-*

=== unix_env/bb.org-overlays/Makefile ===

DTC ?= /usr/bin/dtc
CPP ?= cpp
DESTDIR ?=

MAKEFLAGS += -rR --no-print-directory

ALL_ARCHES := $(patsubst src/%,%,$(wildcard src/*))

PHONY += all
all: $(foreach i,$(ALL_ARCHES),all_$(i))

PHONY += clean
clean: $(foreach i,$(ALL_ARCHES),clean_$(i))

PHONY += install
install: $(foreach i,$(ALL_ARCHES),install_$(i))

# Do not:
# o  use make's built-in rules and variables
#    (this increases performance and avoids hard-to-debug behaviour);
# o  print "Entering directory ...";
MAKEFLAGS += -rR --no-print-directory

# To put more focus on warnings, be less verbose as default
# Use 'make V=1' to see the full commands

ifeq ("$(origin V)", "command line")
  KBUILD_VERBOSE = $(V)
endif
ifndef KBUILD_VERBOSE
  KBUILD_VERBOSE = 0
endif

DTC_FLAGS += -Wno-unit_address_vs_reg
#New DTC Flags for v1.4.5 (Debian 9.x (Buster))
#DTC_FLAGS += -Wno-dmas_property
#DTC_FLAGS += -Wno-gpios_property
#DTC_FLAGS += -Wno-pwms_property
#DTC_FLAGS += -Wno-interrupts_property

# Beautify output
# ---------------------------------------------------------------------------
#
# Normally, we echo the whole command before executing it. By making
# that echo $($(quiet)$(cmd)), we now have the possibility to set
# $(quiet) to choose other forms of output instead, e.g.
#
#         quiet_cmd_cc_o_c = Compiling $(RELDIR)/$@
#         cmd_cc_o_c       = $(CC) $(c_flags) -c -o $@ $<
#
# If $(quiet) is empty, the whole command will be printed.
# If it is set to "quiet_", only the short version will be printed. 
# If it is set to "silent_", nothing will be printed at all, since
# the variable $(silent_cmd_cc_o_c) doesn't exist.
#
# A simple variant is to prefix commands with $(Q) - that's useful
# for commands that shall be hidden in non-verbose mode.
#
#       $(Q)ln $@ :<
#
# If KBUILD_VERBOSE equals 0 then the above command will be hidden.
# If KBUILD_VERBOSE equals 1 then the above command is displayed.

ifeq ($(KBUILD_VERBOSE),1)
  quiet =
  Q =
else
  quiet=quiet_
  Q = @
endif

# If the user is running make -s (silent mode), suppress echoing of
# commands

ifneq ($(filter 4.%,$(MAKE_VERSION)),)	# make-4
ifneq ($(filter %s ,$(firstword x$(MAKEFLAGS))),)
  quiet=silent_
endif
else					# make-3.8x
ifneq ($(filter s% -s%,$(MAKEFLAGS)),)
  quiet=silent_
endif
endif

export quiet Q KBUILD_VERBOSE

all_%:
	$(Q)$(MAKE) ARCH=$* all_arch

clean_%:
	$(Q)$(MAKE) ARCH=$* clean_arch

install_%:
	$(Q)$(MAKE) ARCH=$* install_arch

ifeq ($(ARCH),)

ALL_DTS		:= $(shell find src/* -name \*.dts)

ALL_DTB		:= $(patsubst %.dts,%.dtbo,$(ALL_DTS))

$(ALL_DTB): ARCH=$(word 2,$(subst /, ,$@))
$(ALL_DTB): FORCE
	$(Q)$(MAKE) ARCH=$(ARCH) $@

else

ARCH_DTS	:= $(shell find src/$(ARCH) -name \*.dts)

ARCH_DTB	:= $(patsubst %.dts,%.dtbo,$(ARCH_DTS))

src	:= src/$(ARCH)
obj	:= src/$(ARCH)

include scripts/Kbuild.include

cmd_files := $(wildcard $(foreach f,$(ARCH_DTB),$(dir $(f)).$(notdir $(f)).cmd))

ifneq ($(cmd_files),)
  include $(cmd_files)
endif

quiet_cmd_clean    = CLEAN   $(obj)
      cmd_clean    = rm -f $(__clean-files)

dtc-tmp = $(subst $(comma),_,$(dot-target).dts.tmp)

dtc_cpp_flags  = -Wp,-MD,$(depfile).pre.tmp -nostdinc	\
                 -Iinclude -I$(src) -Itestcase-data	\
                 -undef -D__DTS__

quiet_cmd_dtc = DTC     $@
cmd_dtc = $(CPP) $(dtc_cpp_flags) -x assembler-with-cpp -o $(dtc-tmp) $< ; \
        $(DTC) -O dtb -o $@ -b 0 -@ \
                -i $(src) $(DTC_FLAGS) \
                -d $(depfile).dtc.tmp $(dtc-tmp) ; \
        cat $(depfile).pre.tmp $(depfile).dtc.tmp > $(depfile)

$(obj)/%.dtbo: $(src)/%.dts FORCE
	$(call if_changed_dep,dtc)

PHONY += all_arch
all_arch: $(ARCH_DTB)
	@:

PHONY += install_arch
install_arch: $(ARCH_DTBO)
	mkdir -p $(DESTDIR)/lib/firmware/
	cp -v $(obj)/*.dtbo $(DESTDIR)/lib/firmware/

RCS_FIND_IGNORE := \( -name SCCS -o -name BitKeeper -o -name .svn -o -name CVS \
                   -o -name .pc -o -name .hg -o -name .git \) -prune -o

PHONY += clean_arch
clean_arch: __clean-files = $(ARCH_DTB)
clean_arch: FORCE
	$(call cmd,clean)
	@find . $(RCS_FIND_IGNORE) \
		\( -name '.*.cmd' \
		-o -name '.*.d' \
		-o -name '.*.tmp' \
		\) -type f -print | xargs rm -f

endif

help:
	@echo "Targets:"
	@echo "  all:                   Build all device tree binaries for all architectures"
	@echo "  clean:                 Clean all generated files"
	@echo "  install:               Install all generated files (sudo)"
	@echo ""
	@echo "  all_<ARCH>:            Build all device tree binaries for <ARCH>"
	@echo "  clean_<ARCH>:          Clean all generated files for <ARCH>"
	@echo "  install_<ARCH>:        Install all generated files for <ARCH> (sudo)"
	@echo ""
	@echo "  src/<ARCH>/<DTS>.dtbo   Build a single device tree binary"
	@echo ""
	@echo "Architectures: $(ALL_ARCHES)"

PHONY += FORCE
FORCE:

.PHONY: $(PHONY)


builddeb:
	# build the source package in the parent directory
	# then rename it to project_version.orig.tar.gz
	#$(PYTHON) setup.py sdist $(COMPILE) --dist-dir=../
	#rename -f 's/$(PROJECT)-(.*)\.tar\.gz/$(PROJECT)_$$1\.orig\.tar\.gz/' ../*
	# build the package
	./install.sh
	dpkg-buildpackage -i -I -rfakeroot

=== verilog/rx/Makefile ===
BUILD_DIR = ../../../build
TOOLS_DIR = $(BUILD_DIR)/tools
GEN_DIR = $(BUILD_DIR)/gen

CIC_GEN = $(TOOLS_DIR)/cic_gen
CIC_GEN_DEBUG = $(TOOLS_DIR)/cic_gen_debug

GEN_VERILOG = cic_rx1_12k.vh cic_rx1_20k.vh cic_rx2_12k.vh cic_rx2_20k.vh cic_rx3_12k.vh cic_rx3_20k.vh cic_wf1.vh cic_wf2.vh
FLAGS = -g -I. -I.. -I$(GEN_DIR) -lm

all: $(GEN_VERILOG)

$(TOOLS_DIR):
	@mkdir -p $(TOOLS_DIR)

$(GEN_DIR):
	@mkdir -p $(GEN_DIR)

$(GEN_VERILOG): $(CIC_GEN)
	time ./$(CIC_GEN)

$(CIC_GEN): cic_gen.c $(TOOLS_DIR) Makefile $(GEN_DIR)/kiwi.gen.h
	clang $(FLAGS) -o $@ $<
	
debug: $(CIC_GEN_DEBUG)
	./$(CIC_GEN_DEBUG)

$(CIC_GEN_DEBUG): cic_gen_debug.c $(TOOLS_DIR) Makefile $(GEN_DIR)/kiwi.gen.h
	clang $(FLAGS) -DDEBUG -o $@ $<

diff:
	-diff cic_gen.c cic_gen_debug.c

# leave cic*.vh generated files so distribution has a working default
clean:
	-rm -rf $(TOOLS_DIR)/cic* $(GEN_DIR)

=== web/extensions/Makefile ===
FILES_EMBED_JS += web/extensions/ext.js

# filter out previously optimized
EXT_ALL_W = $(patsubst %.gz,,$(patsubst %.min.css,,$(patsubst %.min.js,,$(addprefix web/,$(FILES_EXT)))))
EXT_EMBED_NW = $(subst web/,,$(shell $(FILE_OPTIM) -t8 -u $(EXT_ALL_W) 2> /dev/null))

.PHONY: foptim_ext
foptim_ext: $(FILE_OPTIM)
	@echo
	@echo '### foptim_ext'
	$(FILE_OPTIM) -t9 -zip $(EXT_ALL_W)

.PHONY: uoptim_ext
uoptim_ext: $(FILE_OPTIM)
	@echo 'EXT_EMBED_NW =' `$(FILE_OPTIM) -t10 -u $(EXT_ALL_W)`

.PHONY: loptim_ext
loptim_ext: $(FILE_OPTIM)
	-ls -la `$(FILE_OPTIM) -l $(EXT_ALL_W)`

.PHONY: roptim_ext
roptim_ext: $(FILE_OPTIM)
#	rm -f `$(FILE_OPTIM) -l $(EXT_ALL_W)`

=== unix_env/bb.org-overlays/debian/changelog ===
device-tree-overlays (0.4.0) UNRELEASED; urgency=low

  [ Elias ]
  * Suport for Relicape Rev B3

 -- Elias <elias@elias-Aspire>  Wed, 23 Dec 2015 14:06:44 +0200

device-tree-overlays (0.1.0) UNRELEASED; urgency=low

  [ Elias ]
  * Initial Debian package

 -- Elias <elias@elias-Aspire>  Thu, 17 Jun 2015 14:06:44 +0200

=== unix_env/bb.org-overlays/debian/control ===
Source: device-tree-overlays
Maintainer: Elias Bakken <elias@iagent.no>
Section: misc
Priority: optional
Standards-Version: 0.4.0
Build-Depends: build-essential

Package: device-tree-overlays
Architecture: armhf
Depends: 
Description: Device tree overlays for Beaglebone.

=== unix_env/bb.org-overlays/debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-


%:
	dh $@ 

clean::
	rm -rf build build-stamp configure-stamp build/ MANIFEST
	dh_clean
